
fasttime = {};
addModEventListener(fasttime);

function fasttime:loadMap(name)
	self.lastTimeScale = g_currentMission.missionInfo.timeScale;
	
	self.inputsActive = false;
end;

function fasttime:INCREASE_FASTTIME_MOD()
	local scale = g_currentMission.missionInfo.timeScale
	
	if scale < 1 then
		scale = self.lastTimeScale + 1;
	elseif scale < 10 then
		scale = self.lastTimeScale + 150;
	elseif scale < 300 then
		scale = self.lastTimeScale + 300;
	elseif scale < 600 then
		scale = self.lastTimeScale + 1000;
	else
		scale = self.lastTimeScale + 2400;
	end;
	
	scale = math.min(scale, 4800)

	g_currentMission:setTimeScale(scale)
	
	self.lastTimeScale = scale;

end;

function fasttime:DECREASE_FASTTIME_MOD()
	local scale = g_currentMission.missionInfo.timeScale
		
	if scale < 150 then
		scale = self.lastTimeScale - 10;
	elseif scale < 300 then
		scale = self.lastTimeScale - 50;
	elseif scale < 600 then
		scale = self.lastTimeScale - 100;
	else
		scale = self.lastTimeScale - 2000;
	end;
	
	scale = math.max(scale, 0.0001)

	g_currentMission:setTimeScale(scale)
	
	self.lastTimeScale = scale;

end;


function fasttime:update(dt)
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil and g_currentMission.controlledVehicle == nil then
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
				if not self.inputsActive then
			        local _ , eventId = g_currentMission.inputManager:registerActionEvent(InputAction.INCREASE_FASTTIME_MOD, fasttime, fasttime.INCREASE_FASTTIME_MOD, false, true, false, true);
					local _ , eventId2 = g_currentMission.inputManager:registerActionEvent(InputAction.DECREASE_FASTTIME_MOD, fasttime, fasttime.DECREASE_FASTTIME_MOD, false, true, false, true);
					self.inputsActive = true;
				end;
			end;
		else
			self.inputsActive = false;
		end;
	end;
	
end


